--***************************************************************
--
-- based on dural's mrGearbox2.lua
-- 
-- version 1.3 by mogli (biedens)
-- 2014/08/06
--
--***************************************************************

if mogliBase == nil or mogliBase.version == nil or mogliBase.version < 1.0 then
	source(Utils.getFilename("mogliBase.lua", g_currentModDirectory))
end
mrGearboxMogli = mogliBase.newSubclass()
mrGearboxMogli.huge = 1000000

function mrGearboxMogli.prerequisitesPresent(specializations) 
	return true
end 

function mrGearboxMogli:load(xmlFile) 
	local key = "vehicle.gearboxMogli"
	if hasXMLProperty(xmlFile, key) then
		mrGearboxMogli.initFromXml(self,xmlFile,key)
	end
end

function mrGearboxMogli.getNoNil2( v0, v1, v2, use2 )
	if v0 == nil then
		if v2 ~= nil and use2 then
			return v2
		end
		return v1
	end
	return v0
end

function mrGearboxMogli:initFromXml(xmlFile,xmlString) 

	self.mrGbMSetGear           = mrGearboxMogli.mrGbMSetGear 
	self.mrGbMSetRange          = mrGearboxMogli.mrGbMSetRange 
	self.mrGbMSetRange2         = mrGearboxMogli.mrGbMSetRange2
	self.mrGbMSetAutomatic      = mrGearboxMogli.mrGbMSetAutomatic 
	self.mrGbMGetClutchPercent  = mrGearboxMogli.mrGbMGetClutchPercent 
	self.mrGbMDoGearShift       = mrGearboxMogli.mrGbMDoGearShift 

	self.mrGbMConfigVersion           = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. "#version" ),1.3)
	self.mrGbMDefaultOn               = Utils.getNoNil(getXMLBool( xmlFile, xmlString .. "#defaultOn" ),true)
	self.mrGbMSwapGearRangeKeys       = Utils.getNoNil(getXMLBool( xmlFile, xmlString .. "#swapGearRangeKeys" ),false)
	
	self.mrGbMRatedRpm                = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. "#ratedRpm"), self.motor.maxRpm-100)  --0.86* self.motor.minRpm) / self.mrGbMRatedRpm  
	self.mrGbMIdleRpm			            = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. "#idleRpm"), 800)  
	self.mrGbMIdleRpmRatio            = self.motor.minRpm / self.mrGbMRatedRpm  
	self.mrGbMOpenRpmRatio            = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. "#clutchOpenRpm"),  self.mrGbMIdleRpm) / self.mrGbMRatedRpm  --0.86* self.motor.minRpm) / self.mrGbMRatedRpm  
	self.mrGbMCloseRpmRatio           = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. "#clutchCloseRpm"), self.mrGbMIdleRpm+100) / self.mrGbMRatedRpm  
	self.mrGbMAutoStartStop           = Utils.getNoNil(getXMLBool( xmlFile, xmlString .. "#autoStartStop"), false)
	
	self.mrGbMClutchEngagingTime      = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. "#clutchEngagingTimeMs"), 1000)  -- 1000 = 1s
	self.mrGbMClutchShiftTime         = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. "#clutchShiftingTimeMs"), 0.25 * self.mrGbMClutchEngagingTime) 
	self.mrGbMTransmissionEfficiency  = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. "#transmissionEfficiency"), 0.93) / 0.88
	self.mrGbMTransmissionEfficiencyDec = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. "#transmissionEfficiencyDec"), 0.07) / 0.88
		
	local alwaysDoubleClutch          = Utils.getNoNil(getXMLBool(xmlFile, xmlString .. "#doubleClutch"), false) 
	self.mrGbMGearsDoubleClutch       = Utils.getNoNil(getXMLBool(xmlFile, xmlString .. ".gears#doubleClutch"), alwaysDoubleClutch) 
	self.mrGbMRange1DoubleClutch      = Utils.getNoNil(getXMLBool(xmlFile, xmlString .. ".ranges(0)#doubleClutch"), alwaysDoubleClutch) 
	self.mrGbMRange2DoubleClutch      = Utils.getNoNil(getXMLBool(xmlFile, xmlString .. ".ranges(1)#doubleClutch"), alwaysDoubleClutch) 
	self.mrGbMReverseDoubleClutch     = Utils.getNoNil(getXMLBool(xmlFile, xmlString .. ".reverse#doubleClutch"), alwaysDoubleClutch) 
	
	self.mrGbMGearTimeToShiftGear     = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. ".gears#shiftTimeMs"),      500 )
	self.mrGbMGearTimeToShiftHl       = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. ".ranges(0)#shiftTimeMs"),  800 ) 
	self.mrGbMGearTimeToShiftRanges2  = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. ".ranges(1)#shiftTimeMs"),  800 ) 
	self.mrGbMGearTimeToShiftReverse  = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. ".reverse#shiftTimeMs"),   1000 ) 

	self.mrGbMClutchAfterShiftGear    = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. ".gears#clutchRatio"), 0.5) 
	self.mrGbMClutchAfterShiftHl      = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. ".ranges(0)#clutchRatio"), 0.5) 
	self.mrGbMClutchAfterShiftRanges2 = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. ".ranges(1)#clutchRatio"), 0.5) 
	self.mrGbMClutchAfterShiftReverse = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. ".reverse#clutchRatio"), 0 ) 
	self.mrGbMMinClutchPercent        = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. "#minClutchRatio"), 0.3 )
	self.mrGbMMaxClutchPercent        = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. "#maxClutchRatio"), 1 )
	self.mrGbMMaxClutchPercentInv     = 1 / self.mrGbMMaxClutchPercent

	self.mrGbMRealMotorBrakeFx        = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. "#motorBrakeFx"), 0.1 )
	
	self.mrGbMMaxEngineRevFx    = ( self.motor.maxRpm - self.motor.rpmFadeOutRange ) / self.mrGbMRatedRpm
	self.mrGbMOverspeedRpmRatio = self.motor.maxRpm / self.mrGbMRatedRpm
		
	local reverseMinGear  = getXMLInt(xmlFile, xmlString .. ".reverse#minGear")
	local reverseMaxGear  = getXMLInt(xmlFile, xmlString .. ".reverse#maxGear")
	local reverseMinRange = getXMLInt(xmlFile, xmlString .. ".reverse#minRange")
	local reverseMaxRange = getXMLInt(xmlFile, xmlString .. ".reverse#maxRange")
	local rangeGearOffset = Utils.getNoNil(getXMLInt(xmlFile, xmlString .. ".ranges#gearOffset"), 0) 
	local gearRangeOffset = Utils.getNoNil(getXMLInt(xmlFile, xmlString .. ".gears#rangeOffset"), 0) 
		
	self.mrGbMGears = {} 
	local i = 0 
	while true do
		local baseName = xmlString .. string.format(".gears.gear(%d)", i) 		
		local speed    = getXMLFloat(xmlFile, baseName .. "#speed") 
		if speed==nil then
			break 
		end 
		i = i + 1 
		local name  = Utils.getNoNil(getXMLString(xmlFile, baseName .. "#name"), tostring(i)) 

		local fwdOnly = getXMLBool(xmlFile, baseName .. "#forwardOnly" )
		if fwdOnly == nil then
			fwdOnly = not ( ( reverseMinGear == nil or i >= reverseMinGear )
									and ( reverseMaxGear == nil or i <= reverseMaxGear ) )
		end		
		local revOnly = Utils.getNoNil( getXMLBool( xmlFile, baseName .. "#reverseOnly" ), false )
		
		local upRangeOffset   = Utils.getNoNil( getXMLInt( xmlFile, baseName .. "#upRangeOffset" ),  -gearRangeOffset ) 
		local downRangeOffset = Utils.getNoNil( getXMLInt( xmlFile, baseName .. "#downRangeOffset" ), gearRangeOffset ) 
		
		local newGear = {speed=speed/3.6,name=name,forwardOnly=fwdOnly,reverseOnly=revOnly,upRangeOffset=upRangeOffset,downRangeOffset=downRangeOffset} 
		
	--print(tostring(newGear.speed).." "..tostring(newGear.name).." "..tostring(newGear.forwardOnly).." "..tostring(newGear.reverseOnly).." "..tostring(newGear.upRangeOffset).." "..tostring(newGear.downRangeOffset))
					
		table.insert(self.mrGbMGears, newGear)  -- m/s
	end 	
	
	if i==0 then
		local newGear = {speed=self.motor.maxForwardSpeed/self.mrGbMMaxEngineRevFx,name="1",forwardOnly=false,reverseOnly=false,upRangeOffset=0,downRangeOffset=0} 
		table.insert(self.mrGbMGears, newGear)  -- m/s
	end 	
			
	self.mrGbMRanges = {} 
	i = 0 
	local generateNames = true 
	while true do
		local baseName = xmlString .. string.format(".ranges(0).range(%d)", i) 		
		local ratio = getXMLFloat(xmlFile, baseName .. "#ratio") 
		if ratio==nil then
			break 
		end 
		i = i + 1 
		
		local name = getXMLString(xmlFile, baseName .. "#name") 
		if name == nil then
			name = tostring(i) 
		else
			generateNames = false 
		end
		
		local fwdOnly = getXMLBool(xmlFile, baseName .. "#forwardOnly" )
		if fwdOnly == nil then
			fwdOnly = not ( ( reverseMinRange == nil or i >= reverseMinRange )
					        and ( reverseMaxRange == nil or i <= reverseMaxRange ) )
		end		
		local revOnly = Utils.getNoNil( getXMLBool(xmlFile, baseName .. "#reverseOnly" ), false )
		
		local upGearOffset   = Utils.getNoNil( getXMLInt( xmlFile, baseName .. "#upGearOffset" ),  -rangeGearOffset ) 
		local downGearOffset = Utils.getNoNil( getXMLInt( xmlFile, baseName .. "#downGearOffset" ), rangeGearOffset ) 
		
		local newRange = {ratio=ratio,name=name,forwardOnly=fwdOnly,reverseOnly=revOnly,upGearOffset=upGearOffset,downGearOffset=downGearOffset} 
		
	--print(tostring(newRange.ratio).." "..tostring(newRange.name).." "..tostring(newRange.forwardOnly).." "..tostring(newRange.reverseOnly).." "..tostring(newRange.upGearOffset).." "..tostring(newRange.downGearOffset))
		
		table.insert(self.mrGbMRanges, newRange)  -- m/s
	end 
	
	if i==0 then
		local newRange = {ratio=1,name="",forwardOnly=false,reverseOnly=false,upGearOffset=0,downGearOffset=0} 
		table.insert(self.mrGbMRanges, newRange)  -- m/s
		generateNames = false
	end
	
	if generateNames then
		local fwd,rev=0,0
		for _,newRange in pairs( self.mrGbMRanges ) do
			if     newRange.forwardOnly then
				fwd = fwd + 1
			elseif newRange.reverseOnly then
				rev = rev + 1
			else
				fwd = fwd + 1
				rev = rev + 1
			end
		end
		
		local fwd2,rev2=0,0

		for _,newRange in pairs( self.mrGbMRanges ) do
			local isFwd,isRev=true,true
			if     newRange.forwardOnly then
				fwd2 = fwd2 + 1
				isRev = false
			elseif newRange.reverseOnly then
				rev2 = rev2 + 1
				isFwd = false
			else
				fwd2 = fwd2 + 1
				rev2 = rev2 + 1
			end
			if     isFwd then
				if     fwd == 1 then
					newRange.name = ""
				elseif fwd == 2 then
					if fwd2 == 1 then
						newRange.name = "L"
					else
						newRange.name = "H"
					end
				elseif fwd == 3 then
					if     fwd2 == 1 then
						newRange.name = "L"
					elseif fwd2 == 2 then
						newRange.name = "M"
					else
						newRange.name = "H"
					end
				elseif fwd == 4 then
					if     fwd2 == 1 then
						newRange.name = "S"
					elseif fwd2 == 2 then
						newRange.name = "L"
					elseif fwd2 == 3 then
						newRange.name = "M"
					else
						newRange.name = "H"
					end
				else
					newRange.name = "G"..tostring(fwd2)
				end
			elseif isRev then
				if rev==1 then
					newRange.name = "R"
				else
					newRange.name = "R"..tostring(rev2)
				end			
			end
		end		
	end
	
	self.mrGbMRanges2 = {} 
	i = 0 
	while true do
		local baseName = xmlString .. string.format(".ranges(1).range(%d)", i) 		
		local ratio = getXMLFloat(xmlFile, baseName .. "#ratio") 
		if ratio==nil then
			break 
		end 
		i = i + 1 
		
		local name = getXMLString(xmlFile, baseName .. "#name") 
		if name == nil then
			name = "G"..tostring(i) 
		end
		
		local fwdOnly = Utils.getNoNil( getXMLBool(xmlFile, baseName .. "#forwardOnly" ), false )
		local revOnly = Utils.getNoNil( getXMLBool(xmlFile, baseName .. "#reverseOnly" ), false )
		
		local newRange = {ratio=ratio,name=name,forwardOnly=fwdOnly,reverseOnly=revOnly} 
		table.insert(self.mrGbMRanges2, newRange)  -- m/s
	end 
	
	if i==0 then
		local newRange = {ratio=1,name="",forwardOnly=false,reverseOnly=false} 
		table.insert(self.mrGbMRanges2, newRange)  -- m/s
	end
		
	self.mrGbMReverseRatio            = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. ".reverse#ratio"), 1) 
	
	
	
	self.mrGbMReverseResetGear        = false 
	if getXMLBool(xmlFile, xmlString .. ".reverse#resetGear") or getXMLBool(xmlFile, xmlString .. ".gears#reverseReset") then
		self.mrGbMReverseResetGear      = true 
	end
	self.mrGbMReverseResetRange       = false 
	if getXMLBool(xmlFile, xmlString .. ".reverse#resetRange") or getXMLBool(xmlFile, xmlString .. ".ranges(0)#reverseReset") then
		self.mrGbMReverseResetRange     = true
	end
	self.mrGbMReverseResetRange2      = false
	if getXMLBool(xmlFile, xmlString .. ".ranges(1)#reverseReset") then
		self.mrGbMReverseResetRange2    = true
	end
	
	--RealisticUtils.testClass("mrGearboxMogli - mrGbMGears", self.mrGbMGears) 
	
	self.mrGbMDefaultGear     = Utils.getNoNil(getXMLInt(xmlFile, xmlString .. ".gears#defaultGear"), 1) 
	self.mrGbMDefaultRange    = Utils.getNoNil(getXMLInt(xmlFile, xmlString .. ".ranges(0)#defaultRange"), table.getn(self.mrGbMRanges)) 
	self.mrGbMDefaultRange2   = Utils.getNoNil(getXMLInt(xmlFile, xmlString .. ".ranges(1)#defaultRange"), table.getn(self.mrGbMRanges2)) 

	self.mrGbMAutoShiftTimeout   = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. ".gears#autoShiftTimeout"), 2000 ) 
	self.mrGbMAutoShiftTimeout2  = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. ".gears#autoShiftTimeout2"), 500 ) 
	self.mrGbMAutoShiftUpTimer   = 0
	self.mrGbMAutoShiftDownTimer = 0
	self.mrGbMCurrentGearSpeed   = 0
	
	local f
	f = getXMLFloat(xmlFile, xmlString .. ".gears#autoUpRpm") 
	if f ~= nil then
		self.mrGbMAutoShiftUpRpmRatio = f / self.mrGbMRatedRpm
	end
	f = getXMLFloat(xmlFile, xmlString .. ".gears#autoDownRpm") 
	if f ~= nil then
		self.mrGbMAutoShiftDownRpmRatio = f / self.mrGbMRatedRpm
	end
	
	self.mrGbMAutoShiftMinMaxFactor = 1
	if self.mrGbMAutoShiftUpRpmRatio  ~= nil and self.mrGbMAutoShiftDownRpmRatio ~= nil then
		self.mrGbMAutoShiftMinMaxFactor = self.mrGbMAutoShiftUpRpmRatio / self.mrGbMAutoShiftDownRpmRatio 
	end
	
	mogliBase.registerState( self, "mrGbMFirstTimeRun",  false )
	mogliBase.registerState( self, "mrGbMClutchPressed", false )
	mogliBase.registerState( self, "mrGbMAutomatic",     self.mrGbMAutoShiftUpRpmRatio ~= nil or self.mrGbMAutoShiftDownRpmRatio ~= nil )
	mogliBase.registerState( self, "mrGbMDrawText",      "off" )
	mogliBase.registerState( self, "mrGbMIsOn",          false,                  mrGearboxMogli.mrGbMOnSetIsOn )
	mogliBase.registerState( self, "mrGbMIsOnOff",       self.mrGbMDefaultOn )
	mogliBase.registerState( self, "mrGbMReverseActive", false,                  mrGearboxMogli.mrGbMOnSetReverse )
	mogliBase.registerState( self, "mrGbMNeutralActive", true,                   mrGearboxMogli.mrGbMOnSetNeutral ) 	
	mogliBase.registerState( self, "mrGbMCurrentGear",   self.mrGbMDefaultGear,  mrGearboxMogli.mrGbMOnSetGear ) 
	mogliBase.registerState( self, "mrGbMCurrentRange",  self.mrGbMDefaultRange, mrGearboxMogli.mrGbMOnSetRange )
	mogliBase.registerState( self, "mrGbMCurrentRange2", self.mrGbMDefaultRange2,mrGearboxMogli.mrGbMOnSetRange2 )
	mogliBase.registerState( self, "mrGbMWarningText",   "",                     mrGearboxMogli.mrGbMOnSetWarningText )

	self.mrGbMWarningTimer       = 0	
	self.mrGbMGearShiftingNeeded = 0 
	self.mrGbMGearShiftingTime   = 0 
	self.mrGbMClutchShiftingTime = 0 
	self.mrGbMDoubleClutch       = false
	self.mrGbMLastMinThrottle    = self.mrGbMIdleRpmRatio 
	self.mrGbMLastMotorLoad      = 0 
	self.mrGbMEngineRevDownTimeMs= 1000
	self.mrGbMEngineRevUpTimeMs  = 1000
	self.mrGbMEngineRpmMinus     = - self.mrGbMRatedRpm / self.mrGbMEngineRevDownTimeMs 
	self.mrGbMEngineRpmPlus      =   self.mrGbMRatedRpm / self.mrGbMEngineRevUpTimeMs 
	self.mrGbMDirtyFlag          = self:getNextDirtyFlag() 
	self.mrGbMCurrentRpmRatio    = self.mrGbMIdleRpmRatio 
	self.mrGbMClutchPercent      = self.mrGbMMinClutchPercent 
	self.mrGbMWantedMinRpmRatio  = 0
	self.mrGbMWantedAcceleration = 0
	self.mrGbMMaxPossibleRpm     = self.mrGbMRatedRpm * self.mrGbMOverspeedRpmRatio
	
	self.mrGbMLastSumDt          = 0 
	self.mrGbMDrawClutch         = 0 
	self.mrGbMLastDrawClutch     = 0 
  self.mrGbMDrawLoad           = 0   
  self.mrGbMLastDrawLoad       = 0   
  self.mrGbMDrawSpeed          = 0 
  self.mrGbMLastDrawSpeed      = 0 
	self.mrGbMDrawFuel           = 0 
	self.mrGbMMotorMinRpm         = self.motor.minRpm
	self.mrGbMMinForwardGearRatio = self.motor.minForwardGearRatio
	self.mrGbMMaxForwardGearRatio = self.motor.maxForwardGearRatio
	self.mrGbMLastSlipFactor      = 0
	
	self.realClutchPercent = 0

end 

function mrGearboxMogli:readStream(streamId, connection)
	self.mrGbMIsOn              = streamReadBool(streamId) 
	self.mrGbMCurrentGear       = streamReadInt8(streamId) 
	self.mrGbMCurrentRange      = streamReadInt8(streamId) 
	self.mrGbMCurrentRange2     = streamReadInt8(streamId) 
	self.mrGbMReverseActive     = streamReadBool(streamId) 
	self.mrGbMNeutralActive     = streamReadBool(streamId) 
	self.mrGbMAutomatic         = streamReadBool(streamId) 
	self.mrGbMClutchPressed     = streamReadBool(streamId) 
	self.mrGbMWantedMinRpmRatio      = streamReadFloat32(streamId) 
end 
 
function mrGearboxMogli:writeStream(streamId, connection)
	streamWriteBool(streamId, self.mrGbMIsOn) 	
	streamWriteInt8(streamId, self.mrGbMCurrentGear) 
	streamWriteInt8(streamId, self.mrGbMCurrentRange) 
	streamWriteInt8(streamId, self.mrGbMCurrentRange2) 
	streamWriteBool(streamId, self.mrGbMReverseActive) 	
	streamWriteBool(streamId, self.mrGbMNeutralActive) 	
	streamWriteBool(streamId, self.mrGbMAutomatic) 	
	streamWriteBool(streamId, self.mrGbMClutchPressed) 	
	streamWriteFloat32(streamId, self.mrGbMWantedMinRpmRatio) 
end 

function mrGearboxMogli:update(dt)
	
	if not ( self.mrGbMFirstTimeRun ) and self.isServer then
		self:mbSetState( "mrGbMCurrentGear",   mrGearboxMogli.mrGbMGetNewEntry( self, self.mrGbMGears,   self.mrGbMDefaultGear,   "gear" ) )
		self:mbSetState( "mrGbMCurrentRange",  mrGearboxMogli.mrGbMGetNewEntry( self, self.mrGbMRanges,  self.mrGbMDefaultRange,  "range" ) )
		self:mbSetState( "mrGbMCurrentRange2", mrGearboxMogli.mrGbMGetNewEntry( self, self.mrGbMRanges2, self.mrGbMDefaultRange2, "range2" ) )
		self:mbSetState( "mrGbMFirstTimeRun", true )
		self.mrGbMMinForwardGearRatio = self.motor.minForwardGearRatio
		self.mrGbMMaxForwardGearRatio = self.motor.maxForwardGearRatio
		self.mrGbMLowBrakeForceScale  = self.motor.lowBrakeForceScale
		
		self.mrGbMTorqueCurveBackup = self.motor.torqueCurve
		self.mrGbMTorqueCurve       = AnimCurve:new( self.motor.torqueCurve.interpolator, self.motor.torqueCurve.interpolatorDegree )
		local zeroTorqueRpm = 0.5*self.motor.minRpm
		self.mrGbMTorqueCurve:addKeyframe( {v=0, time=0} )
		self.mrGbMTorqueCurve:addKeyframe( {v=0, time=zeroTorqueRpm} )
		for _,k in pairs(self.motor.torqueCurve.keyframes) do
			if k.time > zeroTorqueRpm then 
				self.mrGbMTorqueCurve:addKeyframe( k )
			end
		end
	end

	if self.isServer then
		local text = ""
		if self.isAITractorActivated or self.isAIThreshing then
			text = "AI"
		elseif not ( self.isMotorStarted ) then
			text = "off"
		elseif self.mrGbMNeutralActive then
			if self.mrGbMReverseActive then
				text = "neutral (R)" 	
			else
				text = "neutral" 	
			end
		elseif self.mrGbMAutomatic then
			text = "auto" 	
		else
			text = "manual" 	
		end
		
		self:mbSetState( "mrGbMDrawText", text )
	end
	
	if self:getIsActiveForInput(false) and self.mrGbMFirstTimeRun then
		if InputBinding.hasEvent(InputBinding.mrGearboxMogliON_OFF) then
			self:mbSetState( "mrGbMIsOnOff", not self.mrGbMIsOnOff ) 
		end
			
		if self.mrGbMIsOn then
			
			local driveControlShuttle = false
			if      g_currentMission.driveControl ~= nil 
					and g_currentMission.driveControl.useModules ~= nil
					and g_currentMission.driveControl.useModules.shuttle
					and self.driveControl ~= nil
					and self.driveControl.shuttle ~= nil 
					and self.driveControl.shuttle.isActive then
				driveControlShuttle = true
				if     self.driveControl.shuttle.direction > 0 then
					self:mbSetState( "mrGbMReverseActive", false ) 
				elseif self.driveControl.shuttle.direction < 0 then
					self:mbSetState( "mrGbMReverseActive", true ) 
				else
					self:mbSetState( "mrGbMNeutralActive", true) 
				end
			end
		
			if      self.mrGbMWarningText ~= nil
					and self.mrGbMWarningText ~= "" then
				if g_currentMission.time < self.mrGbMWarningTimer then
					g_currentMission:addWarning(self.mrGbMWarningText, 0.018, 0.033)
				else
					self.mrGbMWarningText = ""
				end
			end
			-- auto start/stop
			if      self.mrGbMAutoStartStop
					and self.mrGbMNeutralActive 			
					and ( self.axisForward < -0.1 or self.cruiseControl.isActive ) then
				self:mbSetState( "mrGbMNeutralActive", false) 
			end

			if     InputBinding.hasEvent(InputBinding.mrGearboxMogliNEUTRAL) then
				if self.mrGbMAutoShiftUpRpmRatio ~= nil or self.mrGbMAutoShiftDownRpmRatio ~= nil then
					if self.mrGbMNeutralActive == self.mrGbMAutomatic then
						self:mbSetState( "mrGbMNeutralActive", not self.mrGbMNeutralActive ) 
						self:mrGbMSetAutomatic( true ) 
					else
						self:mrGbMSetAutomatic( not self.mrGbMAutomatic ) 
					end					
				else	
					if not self.mrGbMNeutralActive then
						self:setCruiseControlState(0)
					end
					self:mbSetState( "mrGbMNeutralActive", not self.mrGbMNeutralActive ) 
				end
			elseif not ( driveControlShuttle ) and InputBinding.hasEvent(InputBinding.mrGearboxMogliREVERSE) then			
				self:setCruiseControlState(0)
				self:mbSetState( "mrGbMReverseActive", not self.mrGbMReverseActive ) 
			elseif InputBinding.hasEvent(InputBinding.mrGearboxMogliSHIFTRANGE2UP) then -- high/low range shift
				self:mrGbMSetRange2(self.mrGbMCurrentRange2+1)                                        
			elseif InputBinding.hasEvent(InputBinding.mrGearboxMogliSHIFTRANGE2DOWN) then -- high/low range shift
				self:mrGbMSetRange2(self.mrGbMCurrentRange2-1) 
			elseif InputBinding.hasEvent(InputBinding.mrGearboxMogliMINRPMUP) then -- manual throttle up
				self:mbSetState( "mrGbMWantedMinRpmRatio", Utils.clamp( self.mrGbMWantedMinRpmRatio + 0.1, 0, 1) )                                       
			elseif InputBinding.hasEvent(InputBinding.mrGearboxMogliMINRPMDOWN) then -- manual throttle down
				self:mbSetState( "mrGbMWantedMinRpmRatio", Utils.clamp( self.mrGbMWantedMinRpmRatio - 0.1, 0, 1) )                                       
			elseif InputBinding.hasEvent(InputBinding.mrGearboxMogliSHIFTRANGEUP) then -- high/low range shift
				if self.mrGbMSwapGearRangeKeys then
					self:mrGbMSetGear(self.mrGbMCurrentGear+1) 
				else
					self:mrGbMSetRange(self.mrGbMCurrentRange+1)                                        
				end 
			elseif InputBinding.hasEvent(InputBinding.mrGearboxMogliSHIFTRANGEDOWN) then -- high/low range shift
				if self.mrGbMSwapGearRangeKeys then
					self:mrGbMSetGear(self.mrGbMCurrentGear-1) 	
				else
					self:mrGbMSetRange(self.mrGbMCurrentRange-1) 
				end 
			elseif InputBinding.hasEvent(InputBinding.mrGearboxMogliSHIFTGEARUP) then
				if self.mrGbMSwapGearRangeKeys then
					self:mrGbMSetRange(self.mrGbMCurrentRange+1)                                        
				else
					self:mrGbMSetGear(self.mrGbMCurrentGear+1) 
				end 
			elseif InputBinding.hasEvent(InputBinding.mrGearboxMogliSHIFTGEARDOWN) then
				if self.mrGbMSwapGearRangeKeys then
					self:mrGbMSetRange(self.mrGbMCurrentRange-1) 
				else
					self:mrGbMSetGear(self.mrGbMCurrentGear-1) 	
				end 
			end 
			
			self:mbSetState( "mrGbMClutchPressed", InputBinding.isPressed(InputBinding.mrGearboxMogliCLUTCH) ) 		
		end 
	end 
		
--**********************************************************************************************************		
--**********************************************************************************************************		
	if self.isServer and self.isActive and self.mrGbMIsOn and self.mrGbMFirstTimeRun then	
--**********************************************************************************************************		
						
--**********************************************************************************************************		
		-- defaults
		-- self.motor.torqueCurve = self.mrGbMTorqueCurve
		
		self.mrGbMWantedAcceleration = math.max( -self.axisForward, self.mrGbMWantedMinRpmRatio )
		self.motor.minRpm = self.mrGbMIdleRpm
		
--**********************************************************************************************************	
		-- current RPM and power
		local minRpm           = self.mrGbMIdleRpm 
		local maxWheelRpm      = math.max( self.mrGbMCurrentGearSpeed * 9.5492965855137201461330258023509, 1E-3 )
		local accRpm           = self.mrGbMMaxPossibleRpm --minRpm + math.max( self.mrGbMMaxPossibleRpm - minRpm, 0 ) * self.mrGbMWantedAcceleration
		local currentWheelRpm  = math.max( self.lastSpeed * 9549.2965855137201461330258023509 / maxWheelRpm, 0 )	
		local currentEngineRpm = self.motor.nonClampedMotorRpm --accRpm * ( 1 - self.realClutchPercent ) + self.realClutchPercent * currentWheelRpm 
		local currentRpmRatio  = currentEngineRpm / self.mrGbMRatedRpm		

		self.mrGbMCurrentRpmRatio = currentRpmRatio
		self.mrGbMNoTransmission  = false

		
		local minRpmRatio        = minRpm / self.mrGbMRatedRpm 		
		self.mrGbMMaxPossibleRpm = self.mrGbMRatedRpm * self.mrGbMOverspeedRpmRatio
		self.motor.lowBrakeForceScale = 0
		local motorLoad = Utils.clamp( self.motor.motorLoad, 0, 1 ) 			
		--if self.realClutchPercent >= 1E-3 then
		--	motorLoad = Utils.clamp( self.motor.motorLoad /  math.sqrt( self.realClutchPercent ), 0, 1 ) 			
		--end
		self.mrGbMLastMotorLoad	= self.mrGbMLastMotorLoad	+ 0.1 * ( motorLoad - self.mrGbMLastMotorLoad )
		
--**********************************************************************************************************		
		if     self.mrGbMNeutralActive
		    or ( currentRpmRatio            <= 1.05 * minRpmRatio 
		     and self.mrGbMWantedAcceleration <= -0.01
				 and not self.cruiseControl.isActive ) 
				or ( self.realClutchPercent      <= 0
				 and self.mrGbMClutchPressed ) then
		-- neutral or braking
		  if self.mrGbMAutoStartStop and self.lastSpeed <= 0.1 and not self.mrGbMClutchPressed then
				self:mbSetState( "mrGbMNeutralActive", true) 
			end
			
			if self.mrGbMGearShiftingNeeded > 0 then
				if g_currentMission.time>=self.mrGbMGearShiftingTime then
					if self.mrGbMGearShiftingNeeded < 2 then	
						self:mrGbMDoGearShift() 
					end 
					self.mrGbMGearShiftingNeeded = 0 
				elseif self.mrGbMGearShiftingNeeded < 2 then	
					if self.realClutchPercent <= 0 then
						self:mrGbMDoGearShift() 
					end 
				end 
			end

			self.realClutchPercent    = math.max( 0, self.realClutchPercent -dt/self.mrGbMClutchEngagingTime ) 
			maxWheelRpm               = 0
			self.mrGbMLastSlipFactor  = 0
		  self.mrGbMNoTransmission  = true
--**********************************************************************************************************		
		else
			if self.mrGbMGearShiftingNeeded > 0 then
			-- during gear shifting
				
				if self.mrGbMGearShiftingNeeded == 2 and g_currentMission.time < self.mrGbMGearShiftingTime then	
					if self.mrGbMCurrentRpmRatio > 0.9 * math.min( 1, self.mrGbMMaxEngineRevFx ) then
						self.mrGbMGearShiftingNeeded  = 3
					else
						self.mrGbMNoTransmission      = true
					end
					self.mrGbMCurrentRpmRatio       = Utils.clamp( self.mrGbMCurrentRpmRatio + dt/self.mrGbMEngineRevUpTimeMs, minRpmRatio, self.mrGbMMaxEngineRevFx ) 
				else
					self.mrGbMCurrentRpmRatio       = Utils.clamp( self.mrGbMCurrentRpmRatio - dt/self.mrGbMEngineRevDownTimeMs, minRpmRatio, self.mrGbMMaxEngineRevFx )
				end

				if g_currentMission.time >= self.mrGbMGearShiftingTime then
					if self.mrGbMGearShiftingNeeded < 2 then	
						self:mrGbMDoGearShift() 
					end 
					self.mrGbMGearShiftingNeeded = 0 
				elseif self.mrGbMGearShiftingNeeded < 2 then	
					if self.realClutchPercent > 0 and g_currentMission.time < self.mrGbMClutchShiftingTime then
						self.realClutchPercent     = Utils.clamp( ( self.mrGbMClutchShiftingTime - g_currentMission.time )/self.mrGbMClutchShiftTime, 0, self.realClutchPercent ) 					
					else
						self.realClutchPercent     = 0 
						self:mrGbMDoGearShift() 
					end 
				else
					self.realClutchPercent       = 0 
				end 
				
				self.mrGbMMaxPossibleRpm = self.mrGbMCurrentRpmRatio * self.mrGbMRatedRpm
				
	--**********************************************************************************************************		
			elseif  self.lastSpeed > 0.3
					and self.mrGbMCurrentRpmRatio + self.mrGbMCurrentRpmRatio < minRpmRatio + self.mrGbMMaxEngineRevFx
					and ( (     self.mrGbMReverseActive and self.movingDirection > 0 ) 
						 or ( not self.mrGbMReverseActive and self.movingDirection < 0 ) ) then
			-- wrong direction
				self.mrGbMCurrentRpmRatio     = Utils.clamp( self.mrGbMCurrentRpmRatio - dt/self.mrGbMEngineRevDownTimeMs, minRpmRatio, self.mrGbMMaxEngineRevFx )
				self.mrGbMNoTransmission      = true
			else
	--**********************************************************************************************************		
	-- normal drive with gear and clutch
				self.mrGbMNoTransmission = false
				self.motor.lowBrakeForceScale = self.mrGbMRealMotorBrakeFx

	--**********************************************************************************************************		
				-- acceleration for idle/minimum rpm
				if self.mrGbMWantedAcceleration <= 0.1 or self.mrGbMCurrentRpmRatio < minRpmRatio then
					local delta     = self.mrGbMCurrentRpmRatio - minRpmRatio 
					local throttle  = Utils.clamp( 42 * delta, -1, 1 )^3  
					self.mrGbMLastMinThrottle = Utils.clamp( self.mrGbMLastMinThrottle - 0.01 * throttle, 0.05, math.min( minRpmRatio, 0.9 ) ) 
				end
				
	--**********************************************************************************************************		
	-- automatic shifting
				self.mrGbMCurrentRpmRatio  = currentRpmRatio 
				--no auto parkbrake when a gear is engaged
				local factorFx     = self.mrGbMLastMotorLoad 
				
				-- semi automatic transmission
				if      self.mrGbMAutomatic
						and not self.mrGbMClutchPressed then
														
					local diff = 0 
					local autoDownRpmRatio, autoUpRpmRatio = minRpmRatio, 1 
					
					if self.mrGbMAutoShiftDownRpmRatio ~= nil then
						if      factorFx                        <  1
								and self.mrGbMAutoShiftDownRpmRatio >  minRpmRatio then
							diff = (1 - factorFx) * ( self.mrGbMAutoShiftDownRpmRatio - minRpmRatio ) 
						else
							diff = 0
						end
						autoDownRpmRatio  = math.max( minRpmRatio, self.mrGbMAutoShiftDownRpmRatio - diff ) 
					end 
					if self.mrGbMAutoShiftUpRpmRatio ~= nil then
						if      factorFx                        <  1
								and self.mrGbMAutoShiftDownRpmRatio ~= 0 
								and self.mrGbMAutoShiftUpRpmRatio   >  minRpmRatio * self.mrGbMAutoShiftMinMaxFactor then
							diff = (1 - factorFx) * ( self.mrGbMAutoShiftUpRpmRatio - minRpmRatio * self.mrGbMAutoShiftMinMaxFactor ) 
						else
							diff = 0
						end
						autoUpRpmRatio  = math.min( 1, self.mrGbMAutoShiftUpRpmRatio - diff ) 
					end 
					
					-- shift down					
					if 			self.mrGbMAutoShiftDownRpmRatio ~= nil 
							and self.mrGbMCurrentGear           > 1 
							and ( currentRpmRatio              < minRpmRatio
								 or ( g_currentMission.time                   > self.mrGbMAutoShiftDownTimer 
									and self.mrGbMWantedAcceleration > 0.1 
									and currentRpmRatio            < autoDownRpmRatio )) then
						self:mrGbMSetGear(self.mrGbMCurrentGear-1) 
					
					-- shift up				
					elseif  self.mrGbMAutoShiftUpRpmRatio   ~= nil 
							and self.mrGbMCurrentGear           < table.getn( self.mrGbMGears )
							and ( currentRpmRatio              > 1
								 or ( g_currentMission.time                   > self.mrGbMAutoShiftUpTimer 	
									and self.mrGbMWantedAcceleration > 0.1 
									and currentRpmRatio            > autoUpRpmRatio )) then
						self:mrGbMSetGear(self.mrGbMCurrentGear+1) 
					end
				end
			

	--**********************************************************************************************************		
	-- clutch
				local targetClutchPercent = self.mrGbMMaxClutchPercent 
					
				if self.mrGbMClutchPressed then
					targetClutchPercent = self.mrGbMMinClutchPercent
				end

				local openRpmRatio = minRpmRatio
				if self.mrGbMOpenRpmRatio > minRpmRatio then
					openRpmRatio = minRpmRatio + factorFx * ( self.mrGbMOpenRpmRatio - minRpmRatio )
				end
					
				local refRpmRatio   = math.max( minRpmRatio, currentRpmRatio )
				local closeRpmRatio = refRpmRatio
				if self.mrGbMCloseRpmRatio > refRpmRatio then
					closeRpmRatio = refRpmRatio + factorFx * ( self.mrGbMCloseRpmRatio - refRpmRatio )
				end
				
				targetClutchPercent = self:mrGbMGetClutchPercent( openRpmRatio, closeRpmRatio ) 

				if     dt > self.mrGbMClutchEngagingTime then
					self.realClutchPercent = Utils.clamp( targetClutchPercent, self.mrGbMMinClutchPercent, self.mrGbMMaxClutchPercent ) 
				elseif targetClutchPercent < self.realClutchPercent then
					self.realClutchPercent = math.max( self.mrGbMMinClutchPercent, self.realClutchPercent - math.min( dt/self.mrGbMClutchEngagingTime, self.realClutchPercent - targetClutchPercent ) ) 
				else
					self.realClutchPercent = math.min( self.mrGbMMaxClutchPercent, self.realClutchPercent + math.min( dt/self.mrGbMClutchEngagingTime, targetClutchPercent - self.realClutchPercent ) ) 
				end 
			end 					
			
			local clutch     = self.realClutchPercent
			local clutchRpm  = accRpm * ( 1 - clutch ) + clutch * currentEngineRpm  
			local slipFactor = 1
			if self.realClutchPercent < 1 then
				slipFactor = Utils.clamp( currentEngineRpm / clutchRpm, 0, 1 )
			end
			self.mrGbMLastSlipFactor = slipFactor --self.mrGbMLastSlipFactor + 0.5 * ( slipFactor - self.mrGbMLastSlipFactor )
		end

		if maxWheelRpm > 1E-5 then 
			self.motor.minForwardGearRatio = math.min( self.mrGbMRatedRpm / maxWheelRpm, mrGearboxMogli.huge )
		else
			self.motor.minForwardGearRatio = mrGearboxMogli.huge 
		end

		maxWheelRpm = maxWheelRpm * self.mrGbMLastSlipFactor
		
		if maxWheelRpm > 1E-5 then 
			self.motor.maxForwardGearRatio = math.min( self.mrGbMRatedRpm / maxWheelRpm, mrGearboxMogli.huge )
		else
			self.motor.maxForwardGearRatio = mrGearboxMogli.huge 
		end
	end 	
--**********************************************************************************************************		
--**********************************************************************************************************		

end 

function mrGearboxMogli:mrGbMGetClutchPercent( openRpmRatio, closeRpmRatio, gearSpeed )
	if self.mrGbMClutchPressed or self.mrGbMCurrentRpmRatio <= openRpmRatio then
		return self.mrGbMMinClutchPercent
	elseif self.mrGbMCurrentRpmRatio >= closeRpmRatio then
		return self.mrGbMMaxClutchPercent 					
	end
	return self.mrGbMMinClutchPercent + ( self.mrGbMMaxClutchPercent - self.mrGbMMinClutchPercent ) * ( self.mrGbMCurrentRpmRatio - openRpmRatio ) / ( closeRpmRatio - openRpmRatio )
end

function mrGearboxMogli:mrGbMDoGearShift(increaseOnly)
	if self.isServer then
		if self.mrGbMDoubleClutch then
			self.mrGbMGearShiftingNeeded = 2
		else
			self.mrGbMGearShiftingNeeded = 3
		end
		local gearMaxSpeed = self.mrGbMGears[self.mrGbMCurrentGear].speed 
		                   * self.mrGbMRanges[self.mrGbMCurrentRange].ratio 
											 * self.mrGbMRanges2[self.mrGbMCurrentRange2].ratio
											 * self.mrGbMMaxEngineRevFx
		if self.mrGbMReverseActive then	
			gearMaxSpeed = gearMaxSpeed * self.mrGbMReverseRatio 
		end
		
		--mogliBase.debugEvent( self, gearMaxSpeed, self.mrGbMCurrentGearSpeed, increaseOnly )
		
		if increaseOnly then
			self.mrGbMCurrentGearSpeed = math.max( gearMaxSpeed, self.mrGbMCurrentGearSpeed )
		else
			self.mrGbMCurrentGearSpeed = gearMaxSpeed 
		end
		
		self.mrSEFLastEngineRevFx = nil
	end 
end 

function mrGearboxMogli:updateTick(dt)

	if self.isActive then
		if self.isServer then
			if self.isAITractorActivated or self.isAIThreshing then
				self:mbSetState( "mrGbMIsOn", false ) 
			elseif  self.isMotorStarted 
					and self.mrGbMIsOnOff
					and self.mrGbMFirstTimeRun then
				self:mbSetState( "mrGbMIsOn", true ) 
			else		
				self:mbSetState( "mrGbMIsOn", false ) 
			end 	
		
			if self.mrGbMIsOn then	
					self.mrGbMLastSumDt = self.mrGbMLastSumDt + dt
				
				if self.mrGbMLastSumDt > 200 then
					self.mrGbMDrawClutch = tonumber( math.floor(self.realClutchPercent*self.mrGbMMaxClutchPercentInv*20+0.5)*5 ) 
					self.mrGbMDrawLoad   = tonumber( math.floor(Utils.getNoNil(self.mrGbMLastMotorLoad,0)*20+0.5)*5 ) 			
					self.mrGbMDrawSpeed  = tonumber( math.floor(self.mrGbMCurrentGearSpeed / self.mrGbMMaxEngineRevFx * 3.6 + 0.5 ) ) 

					if self.mrGbMLastFuelFillLevel == nil then
						self.mrGbMLastFuelFillLevel = self.fuelFillLevel
						self.mrGbMDrawFuel          = 0
					else
						local fuelUsed = self.mrGbMLastFuelFillLevel - self.fuelFillLevel
						self.mrGbMLastFuelFillLevel = self.fuelFillLevel
						self.mrGbMDrawFuel          = fuelUsed * (1000 * 3600) / self.mrGbMLastSumDt
					end
					
					if     self.mrGbMLastDrawClutch ~= self.mrGbMDrawClutch
							or self.mrGbMLastDrawLoad   ~= self.mrGbMDrawLoad   
							or self.mrGbMLastDrawSpeed  ~= self.mrGbMDrawSpeed 
							then
						self:raiseDirtyFlags(self.mrGbMDirtyFlag) 
					
						self.mrGbMLastDrawClutch = self.mrGbMDrawClutch
						self.mrGbMLastDrawLoad   = self.mrGbMDrawLoad   
						self.mrGbMLastDrawSpeed  = self.mrGbMDrawSpeed 
					end 
					
					self.mrGbMLastSumDt = 0
				end 
			else
				self.mrGbMLastSumDt         = 0
				self.mrGbMLastFuelFillLevel = self.fuelFillLevel
			end
		end
	end
end 

function mrGearboxMogli:readUpdateStream(streamId, timestamp, connection)
  if connection:getIsServer() then
		if streamReadBool( streamId ) then
			self.mrGbMDrawClutch = streamReadUIntN( streamId ) 
			self.mrGbMDrawLoad   = streamReadUIntN( streamId )  
			self.mrGbMDrawSpeed  = streamReadUIntN( streamId ) 
		end 
  end 
end 

function mrGearboxMogli:writeUpdateStream(streamId, connection, dirtyMask)
  if not connection:getIsServer() then
		if streamWriteBool(streamId, bitAND(dirtyMask, self.mrGbMDirtyFlag) ~= 0) then	
			streamWriteUIntN(streamId, self.mrGbMDrawClutch ) 
			streamWriteUIntN(streamId, self.mrGbMDrawLoad   ) 
			streamWriteUIntN(streamId, self.mrGbMDrawSpeed  ) 
		end 
	end 
end 

function mrGearboxMogli:draw() 	
	
	if self.mrGbMIsOn then
	
		setTextBold(false) 
		setTextAlignment(RenderText.ALIGN_LEFT) 
		setTextColor(1, 1, 1, 1) 
		
		local gearText = self.mrGbMGears[self.mrGbMCurrentGear].name
		if self.mrGbMRanges[self.mrGbMCurrentRange].name ~= nil and self.mrGbMRanges[self.mrGbMCurrentRange].name ~= "" then
			if self.mrGbMSwapGearRangeKeys then
				gearText = gearText .." ".. self.mrGbMRanges[self.mrGbMCurrentRange].name
			else
				gearText = self.mrGbMRanges[self.mrGbMCurrentRange].name .." ".. gearText
			end
		end
		if self.mrGbMRanges2[self.mrGbMCurrentRange2].name ~= nil and self.mrGbMRanges2[self.mrGbMCurrentRange2].name ~= "" then
			gearText = self.mrGbMRanges2[self.mrGbMCurrentRange2].name .." ".. gearText
		end
		
		local drawY0   = 0.706
		local deltaY   = 0.02
		local drawY    = drawY0
		
		renderText(0.85, drawY, deltaY, gearText) 			     
		if self.mrGbMDrawSpeed > 0 then
			drawY = drawY - deltaY renderText(0.85, drawY, deltaY, "Speed.................")
		end
		drawY = drawY - deltaY renderText(0.85, drawY, deltaY, "Rpm...................")
		drawY = drawY - deltaY renderText(0.85, drawY, deltaY, "Clutch................")
		drawY = drawY - deltaY renderText(0.85, drawY, deltaY, "Load..................")
		drawY = drawY - deltaY renderText(0.85, drawY, deltaY, "Fuel used.............")
		
		setTextAlignment(RenderText.ALIGN_RIGHT) 
		
		drawY    = drawY0 
		
		if self.mrGbMDrawSpeed > 0 then
			drawY = drawY - deltaY renderText(0.99,drawY,deltaY, string.format("%3.1f km/h", self.mrGbMDrawSpeed ))
		end
		drawY = drawY - deltaY renderText(0.99, drawY, deltaY, string.format("%4.0f", math.floor(self.motor.lastMotorRpm*0.1+0.5)*10)) 
		drawY = drawY - deltaY renderText(0.99, drawY, deltaY, string.format("%3d %%", self.mrGbMDrawClutch )) 
		drawY = drawY - deltaY renderText(0.99, drawY, deltaY, string.format("%3d %%", self.mrGbMDrawLoad )) 	
		drawY = drawY - deltaY renderText(0.99, drawY, deltaY, string.format("%3d l/h", self.mrGbMDrawFuel ))  		                                                                                                                                 				
	end

	setTextAlignment(RenderText.ALIGN_LEFT) 
	setTextBold(false)
	
end 

function mrGearboxMogli:getSaveAttributesAndNodes(nodeIdent)

	local attributes = ""

	attributes = attributes.." mrGbMCurrentGear=\""  .. tostring(self.mrGbMCurrentGear  ) .. "\""
	attributes = attributes.." mrGbMCurrentRange=\"" .. tostring(self.mrGbMCurrentRange ) .. "\""

	return attributes
end 

function mrGearboxMogli:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
	local i
	
	i = getXMLInt(xmlFile, key .. "#mrGbMCurrentGear" )
	if i ~= nil then
		self.mrGbMDefaultGear = i
	end

	i = getXMLInt(xmlFile, key .. "#mrGbMCurrentRange" )
	if i ~= nil then
		self.mrGbMDefaultRange = i
	end
	
	i = getXMLInt(xmlFile, key .. "#mrGbMCurrentRange2" )
	if i ~= nil then
		self.mrGbMDefaultRange2 = i
	end

	self:mbSetState( "mrGbMFirstTimeRun", false )
	
	return BaseMission.VEHICLE_LOAD_OK
end 

function mrGearboxMogli:mrGbMGetNewEntry( entries, index, name )

	local new = Utils.clamp( index, 1, table.getn( entries ) )

	if self.mrGbMReverseActive then
		if new > self.mrGbMCurrentGear then
			while entries[new].forwardOnly and new < table.getn( entries ) do
				new = new + 1
			end
		end
		while entries[new].forwardOnly and new > 1 do
			new = new -1
		end
		if entries[new].forwardOnly then
			while entries[new].forwardOnly and new < table.getn( entries ) do
				new = new + 1
			end
		end
		if entries[new].forwardOnly then
			print(string.format("no reverse %s found: %d", index, name))
		end
	else
		if new > self.mrGbMCurrentGear then
			while entries[new].reverseOnly and new < table.getn( entries ) do
				new = new + 1
			end
		end
		while entries[new].reverseOnly and new > 1 do
			new = new -1
		end
		if entries[new].reverseOnly then
			while entries[new].reverseOnly and new < table.getn( entries ) do
				new = new + 1
			end
		end
		if entries[new].reverseOnly then
			print(string.format("no forward %s found: %d", index, name))
		end
	end
	
	return new
end

function mrGearboxMogli:mrGbMSpeedLevelCheck( newGear, newRange, newRange2 )
	--if 0 < self.motor.speedLevel and not self.mrGbMAutomatic then
	--	local maxGearSpeed = 3.6 * self.mrGbMGears[newGear].speed * self.mrGbMRanges[newRange].ratio * self.mrGbMRanges2[newRange2].ratio
	--	if self.motor.speedLevel == 4 then
	--		maxGearSpeed = maxGearSpeed * self.mrGbMOverspeedRpmRatio
	--	else
	--		maxGearSpeed = maxGearSpeed * self.mrGbMMaxEngineRevFx
	--	end
  --
	--	if self.mrGbMReverseActive then	
	--		maxGearSpeed = maxGearSpeed * self.mrGbMReverseRatio 
	--	end
	--	if maxGearSpeed < self.motor.realSpeedLevels[self.motor.speedLevel] then
	--		local gearText = self.mrGbMGears[newGear].name
	--		if self.mrGbMRanges[newRange].name ~= nil and self.mrGbMRanges[newRange].name ~= "" then
	--			gearText = self.mrGbMRanges[newRange].name .." ".. gearText
	--		end           
	--		if self.mrGbMRanges2[newRange2].name ~= nil and self.mrGbMRanges2[newRange2].name ~= "" then
	--			gearText = self.mrGbMRanges2[newRange2].name .." ".. gearText
	--		end
	--	
	--		self:mbSetState( "mrGbMWarningText", string.format( "Gear %s is too low for speed level %d", gearText, self.motor.speedLevel ))
  --
	--		return false
	--	end
	--end
	--
	return true
end

function mrGearboxMogli:mrGbMSetGear( new, noEventSend)

	local newGear  = mrGearboxMogli.mrGbMGetNewEntry( self, self.mrGbMGears, new, "gear" )
	local newRange = self.mrGbMCurrentRange
	if not self.mrGbMAutomatic then
		if     newGear > self.mrGbMCurrentGear then 
			newRange = self.mrGbMCurrentRange + self.mrGbMGears[self.mrGbMCurrentGear].upRangeOffset
		elseif newGear < self.mrGbMCurrentGear then 
			newRange = self.mrGbMCurrentRange + self.mrGbMGears[self.mrGbMCurrentGear].downRangeOffset
		end
		newRange = mrGearboxMogli.mrGbMGetNewEntry( self, self.mrGbMRanges, newRange, "range" )
	end
	
	if      newGear ~= self.mrGbMCurrentGear 
			and mrGearboxMogli.mrGbMSpeedLevelCheck( self, newGear, newRange, self.mrGbMCurrentRange2 ) then
		self:mbSetState( "mrGbMCurrentGear",  newGear,  noEventSend ) 		
		self:mbSetState( "mrGbMCurrentRange", newRange, noEventSend ) 
	end
end 

function mrGearboxMogli:mrGbMSetRange(new, noEventSend)

	local newRange = mrGearboxMogli.mrGbMGetNewEntry( self, self.mrGbMRanges, new, "range" )
	local newGear  = self.mrGbMCurrentGear
	if     newRange > self.mrGbMCurrentRange then 
		newGear = self.mrGbMCurrentGear + self.mrGbMRanges[self.mrGbMCurrentRange].upGearOffset
	elseif newRange < self.mrGbMCurrentRange then  
		newGear = self.mrGbMCurrentGear + self.mrGbMRanges[self.mrGbMCurrentRange].downGearOffset
	end
	newGear = mrGearboxMogli.mrGbMGetNewEntry( self, self.mrGbMGears, newGear, "gear" )
	
	if      newRange ~= self.mrGbMCurrentRange
			and mrGearboxMogli.mrGbMSpeedLevelCheck( self, newGear, newRange, self.mrGbMCurrentRange2 ) then
		self:mbSetState( "mrGbMCurrentRange", newRange, noEventSend ) 
		self:mbSetState( "mrGbMCurrentGear",  newGear,  noEventSend ) 		
	end
end

function mrGearboxMogli:mrGbMSetRange2(new, noEventSend)

	local newRange2 = mrGearboxMogli.mrGbMGetNewEntry( self, self.mrGbMRanges2, new, "range2" )
	
	if      newRange2 ~= self.mrGbMCurrentRange2
			and mrGearboxMogli.mrGbMSpeedLevelCheck( self, self.mrGbMCurrentGear, self.mrGbMCurrentRange, newRange2 ) then
		self:mbSetState( "mrGbMCurrentRange2", newRange2, noEventSend ) 
	end
end

function mrGearboxMogli:mrGbMSetAutomatic( value, noEventSend )
	local new = false 
	if value and ( self.mrGbMAutoShiftUpRpmRatio ~= nil or self.mrGbMAutoShiftDownRpmRatio ~= nil ) then
		new = true 
	end 
	self:mbSetState( "mrGbMAutomatic", new, noEventSend ) 		
end 

function mrGearboxMogli:mrGbMPrepareGearShift( timeToShift, clutchPercent, doubleClutch )
	if self.isServer then
		self.mrGbMGearShiftingNeeded  = 1 
		self.mrGbMGearShiftRpmRatio   = self.mrGbMCurrentRpmRatio
		self.mrGbMGearShiftingTime    = math.max( self.mrGbMGearShiftingTime, g_currentMission.time + timeToShift ) 
		self.mrGbMClutchPercent       = math.min( self.realClutchPercent, clutchPercent ) 
		if doubleClutch then
			self.mrGbMDoubleClutch       = true
			self.mrGbMClutchShiftingTime = math.max( self.mrGbMClutchShiftingTime, g_currentMission.time + 0.4 * timeToShift ) 
		else
			self.mrGbMDoubleClutch       = false
			self.mrGbMClutchShiftingTime = math.max( self.mrGbMClutchShiftingTime, g_currentMission.time + self.mrGbMClutchShiftTime ) 
		end
	end 
end

function mrGearboxMogli:mrGbMOnSetReverse( old, new, noEventSend )

	self.mrGbMReverseActive = new 
	--timer to shift the "reverse/forward"
	mrGearboxMogli.mrGbMPrepareGearShift( self, self.mrGbMGearTimeToShiftReverse, self.mrGbMClutchAfterShiftReverse, self.mrGbMReverseDoubleClutch ) 

	local default = self.mrGbMCurrentGear
	if self.mrGbMReverseResetGear then
		default = self.mrGbMDefaultGear
	end
	
	self:mbSetState( "mrGbMDefaultGear", self.mrGbMCurrentGear, noEventSend ) 
	self:mbSetState( "mrGbMCurrentGear", mrGearboxMogli.mrGbMGetNewEntry( self, self.mrGbMGears, default, "gear" ), noEventSend ) 
	
	local default = self.mrGbMCurrentRange
	if self.mrGbMReverseResetRange then
		default = self.mrGbMDefaultRange
	end

	self:mbSetState( "mrGbMDefaultRange", self.mrGbMCurrentRange, noEventSend ) 
	self:mbSetState( "mrGbMCurrentRange", mrGearboxMogli.mrGbMGetNewEntry( self, self.mrGbMRanges, default, "range" ), noEventSend ) 

	local default = self.mrGbMCurrentRange2
	if self.mrGbMReverseResetRange2 then
		default = self.mrGbMDefaultRange2
	end

	self:mbSetState( "mrGbMDefaultRange2", self.mrGbMCurrentRange2, noEventSend ) 
	self:mbSetState( "mrGbMCurrentRange2", mrGearboxMogli.mrGbMGetNewEntry( self, self.mrGbMRanges2, default, "range2" ), noEventSend ) 
	
	if self.isServer then
		self.mrGbMAutoShiftDownTimer = g_currentMission.time + self.mrGbMAutoShiftTimeout 
		self.mrGbMAutoShiftUpTimer   = g_currentMission.time + self.mrGbMAutoShiftTimeout 
	end 
end 
		
function mrGearboxMogli:mrGbMOnSetNeutral( old, new, noEventSend )		
	self.mrGbMNeutralActive = new 
	mrGearboxMogli.mrGbMPrepareGearShift( self, self.mrGbMGearTimeToShiftHl, self.mrGbMClutchAfterShiftHl ) 
end 

function mrGearboxMogli:mrGbMOnSetRange( old, new, noEventSend )
		
	self.mrGbMCurrentRange = new

	--timer to shift the "range"
	mrGearboxMogli.mrGbMPrepareGearShift( self, self.mrGbMGearTimeToShiftHl, self.mrGbMClutchAfterShiftHl, self.mrGbMRange1DoubleClutch ) 
	
	if self.isServer then
		self.mrGbMAutoShiftDownTimer = 0
		self.mrGbMAutoShiftUpTimer   = 0
	end 
end 

function mrGearboxMogli:mrGbMOnSetRange2( old, new, noEventSend )
		
	self.mrGbMCurrentRange2 = new

	--timer to shift the "range 2"
	mrGearboxMogli.mrGbMPrepareGearShift( self, self.mrGbMGearTimeToShiftRanges2, self.mrGbMClutchAfterShiftRanges2, self.mrGbMRange2DoubleClutch ) 
	
	if self.isServer then
		self.mrGbMAutoShiftDownTimer = 0
		self.mrGbMAutoShiftUpTimer   = 0
	end 
end 

function mrGearboxMogli:mrGbMOnSetGear( old, new, noEventSend )

	if     new > self.mrGbMCurrentGear then
		if self.isServer then
			self.mrGbMAutoShiftDownTimer = g_currentMission.time + self.mrGbMAutoShiftTimeout 
			self.mrGbMAutoShiftUpTimer   = g_currentMission.time + self.mrGbMAutoShiftTimeout2
		end 
	elseif new < self.mrGbMCurrentGear then                                              
		if self.isServer then
			self.mrGbMAutoShiftDownTimer = g_currentMission.time + self.mrGbMAutoShiftTimeout2
			self.mrGbMAutoShiftUpTimer   = g_currentMission.time + self.mrGbMAutoShiftTimeout 
		end 
	end			
	
-- adjust clutch % to fit rpm after gear shift	
	local clutchPercent = self.mrGbMClutchAfterShiftGear
	if clutchPercent < 0 then
		local gearSpeed = self.mrGbMGears[new].speed * self.mrGbMRanges[self.mrGbMCurrentRange].ratio * self.mrGbMRanges2[self.mrGbMCurrentRange2].ratio
		if self.mrGbMReverseActive then	
			gearSpeed = gearSpeed * self.mrGbMReverseRatio 
		end
		clutchPercent = Utils.clamp( mrGearboxMogli.mrGbMGetClutchPercent( self, self.mrGbMMaxEngineRevFx, self.mrGbMCurrentRpmRatio, gearSpeed ), self.mrGbMMinClutchPercent, self.mrGbMMaxClutchPercent )
	end

	self.mrGbMCurrentGear = new
	
	--timer to set the gear
	mrGearboxMogli.mrGbMPrepareGearShift( self, self.mrGbMGearTimeToShiftGear, clutchPercent, self.mrGbMGearsDoubleClutch ) 	 	
end

function mrGearboxMogli:mrGbMOnSetIsOn( old, new, noEventSend )

	self.mrGbMIsOn = new 
	
	if self.isServer then
		if self.mrGbMIsOn then
				
			if      g_currentMission.driveControl ~= nil 
					and g_currentMission.driveControl.useModules ~= nil
					and g_currentMission.driveControl.useModules.shuttle
					and self.driveControl ~= nil
					and self.driveControl.shuttle ~= nil 
					and self.driveControl.shuttle.isActive then
				if self.driveControl.shuttle.direction < 0 then
					self:mbSetState( "mrGbMReverseActive", true, noEventSend )  -- first gear, H range, reverse
				else
					self:mbSetState( "mrGbMReverseActive", false, noEventSend )  -- first gear, H range, forward
				end 
			end
			self:mrGbMDoGearShift() 
		else
			self:mbSetState( "mrGbMDefaultGear", self.mrGbMCurrentGear, noEventSend ) 
			self:mbSetState( "mrGbMDefaultRange", self.mrGbMCurrentRange, noEventSend ) 
			self:mbSetState( "mrGbMDefaultRange2", self.mrGbMCurrentRange2, noEventSend ) 
			self.mrGbMGearShiftingNeeded   = false 
		  self.motor.minRpm              = self.mrGbMMotorMinRpm
			self.motor.minForwardGearRatio = self.mrGbMMinForwardGearRatio
			self.motor.maxForwardGearRatio = self.mrGbMMaxForwardGearRatio
			self.motor.lowBrakeForceScale	 = self.mrGbMLowBrakeForceScale
			self.motor.torqueCurve         = self.mrGbMTorqueCurveBackup
		end 
	end 
	
end 

function mrGearboxMogli:mrGbMOnSetWarningText( old, new, noEventSend )
	self.mrGbMWarningText  = new
  self.mrGbMWarningTimer = g_currentMission.time + 2000
end

local oldFunc1 = Drivable.getRpmLimit
function Drivable.getRpmLimit( self, ... )
	if self.mrGbMIsOn then
		local rpmLimit = oldFunc1( self, ... )
		return math.min( rpmLimit, self.mrGbMMaxPossibleRpm )		
	else
		return oldFunc1( self, ... )
	end
end

local oldFunc2 = Drivable.updateVehiclePhysics;
function Drivable.updateVehiclePhysics(self, axisForward, axisForwardIsAnalog, axisSide, axisSideIsAnalog, dt)

	if self.mrGbMIsOn then
		if      g_currentMission.driveControl ~= nil 
				and g_currentMission.driveControl.useModules ~= nil
				and g_currentMission.driveControl.useModules.shuttle
				and self.driveControl ~= nil
				and self.driveControl.shuttle ~= nil 
				and self.driveControl.shuttle.isActive then
		-- do nothing
			local acc = -self.driveControl.shuttle.direction * axisForward
			if acc > 0.1 and acc < self.mrGbMLastMinThrottle then
				axisForward = -self.driveControl.shuttle.direction * self.mrGbMLastMinThrottle
				axisForwardIsAnalog = true
			end
		
		else
			local wantedDirection = 1
			if self.mrGbMReverseActive then
				wantedDirection = -1
			end
				
			if wantedDirection < 0 then
				axisForward = -axisForward;
			end;
				
			if self.movingDirection ~= wantedDirection then
				if     wantedDirection < 0 then
					axisForward = Utils.clamp(axisForward,0,1);			
				else
					axisForward = Utils.clamp(axisForward,-1,0);			
				end;
			end
			
			if axisForward < -0.1 then
				if axisForward > - self.mrGbMLastMinThrottle then
					axisForward = -self.mrGbMLastMinThrottle
					axisForwardIsAnalog = true
				end
			end
				
			self.GPSmovingDirection    = wantedDirection
			self.GPSmovingDirectionCnt = 40; --here we remotely handle direction mechanics from GPS. no problem if GPS is not installed
		end
	end
	
	oldFunc2(self, axisForward, axisForwardIsAnalog, axisSide, axisSideIsAnalog, dt)
end;

local oldFunc3 = VehicleMotor.getTorque
function VehicleMotor.getTorque( self, ... )
	local t, b = oldFunc3( self, ... )
	if self.vehicle.mrGbMIsOn then
		--if      self.nonClampedMotorRpm < self.minRpm then
		--	print(tostring(t))
		--	t = t * math.max( self.nonClampedMotorRpm / self.minRpm, 0.1 )
		--end
		if      self.vehicle.mrGbMLastSlipFactor ~= nil 
				and not ( self.vehicle.mrGbMNoTransmission ) 
				and self.vehicle.realClutchPercent >= 1E-3 then
			t = t * ( self.vehicle.mrGbMTransmissionEfficiency - self.vehicle.mrGbMTransmissionEfficiencyDec * ( 1 - self.vehicle.mrGbMLastSlipFactor ) )
		end
	end
	return t, b
end

local oldFunc4 = WheelsUtil.updateWheelsPhysics
function WheelsUtil.updateWheelsPhysics( self, dt, currentSpeed, acceleration, doHandbrake, requiredDriveMode )
	if self.movingDirection * currentSpeed * acceleration >= -1.0E-4 and self.mrGbMIsOn then
		local old = acceleration
		if self.mrGbMNoTransmission or self.realClutchPercent < 1E-3 then
			requiredDriveMode = 99
		--else
		--	acceleration = math.sqrt( self.realClutchPercent ) * acceleration
		end
	end
	return oldFunc4( self, dt, currentSpeed, acceleration, doHandbrake, requiredDriveMode )
end